using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;
using System.IO;
using System.Runtime.CompilerServices;

/// @author Teemu Vesikukka
/// @version 15.10.2023
/// <summary>
/// Käyttäjä voi hoitaa pankkiasioita ohjelman kautta
/// </summary>
public class Pankkiautomaatti
{
    /// <summary>
    /// Pääohjelma joka kysyy pin-koodin kayttajalta ja pin-koodin ollessa oikein, paastaa
    /// asiakkaan omalle tilille
    /// </summary>
    public static void Main()
    {
        double luku = 0.00;
        Aloitus();
        
        if (PinKoodi() == true)
        {
            Valikko();
        }
        Lopetus();
    }

    /// <summary>
    /// Aliohjelma joka aloittaa pyytamalla asiakkaan kortin
    /// </summary>
    public static void Aloitus()
    {
        Console.WriteLine("Tervetuloa!");
        Console.WriteLine("Syota kortti ole hyva");
    }

    /// <summary>
    /// Aliohjelma joka pyytaa asiakkaalta pin-koodin ja koodin
    /// ollessa oikein paastaa asiakkaan kayttamaan tilia
    /// </summary>
    /// <returns>alse or true</returns>
    /// <example>
    /// <pre name="test">
    /// PinKoodi(),"1234"===true;
    /// PinKoodi(),"1111"===false;
    /// </pre>
    /// </example>
    public static bool PinKoodi()
    {
        int yritykset = 0;
        bool onkoOikein = false;
        string pinkoodi = "1234";
        while (yritykset <= 3 && onkoOikein == false)
        {
            if (yritykset <= 1)
            {
                Console.Write("Anna pin koodi: ");
                string syote = Console.ReadLine();
                yritykset++;
                if (syote.Equals(pinkoodi))
                {
                    Console.WriteLine("Pin kood oikein");
                    onkoOikein = true;
                    break;
                }
            }
            else
            {
                Console.WriteLine("Pin koodi vaarin!");
                Console.WriteLine("Yritä uudelleen: ");
                string syote = Console.ReadLine();
                yritykset++;
                if (syote.Equals(pinkoodi))
                {
                    Console.WriteLine("Pin koodi oikein!");
                    onkoOikein = true;
                }
                else
                {
                    Console.WriteLine("Annoit kolme kertaa pin koodin vaarin");
                    Console.WriteLine("Kortti on otettu talteen");
                    onkoOikein = false; 
                }
            }
            return onkoOikein;
        }
        return onkoOikein;
    }

    //int syote = Convert.ToInt32(Console.ReadLine());
    /// <summary>
    /// Aliohjelma joka on ohjelman paavalikko
    /// </summary>
    public static void Valikko()
    {
        double saldo = alkuSaldo(600.00);
        while (true)
        {
            Console.WriteLine("Jos haluat saldon kirjoita saldo: ");
            Console.WriteLine("Jos haluat tiliotteen kirjoita ote");
            Console.WriteLine("Jos haluat nostaa kirjoita otto");
            Console.WriteLine("Jos haluat pysayttaa kirjoita stop");
            Console.WriteLine("Jos haluat tallettaa tilille rahaa kirjoita talletus");
            string tapahtuma = Console.ReadLine();
            if (tapahtuma == "saldo")
            {
                tulostaSaldo(saldo);
            }
            else if (tapahtuma == "ote")
            {
                tulostaTilitapahtumat();
            }
            else if (tapahtuma == "otto")
            {
                saldo = Nosto(saldo);
            }
            else if (tapahtuma == "talletus")
            {
                saldo = Talletus(saldo);
            }
            else if(tapahtuma == "stop")
            {
                break;
            }
        }
    }
    /// <summary>
    /// Aliohjelma joka ottaa tililta rahaa asiakkaan nostaessa tililta rahaa
    /// Tilin saldon ollessa liian pieni tililta ei pysty nostamaan rahaa
    /// </summary>
    /// <param name="saldo">parametrina viedaan saldo</param>
    /// <returns>palauttaa tilin saldon</returns>
    /// <example>
    /// <pre name="test">
    /// saldo = 200.00
    /// 
    /// </pre>
    /// </example>
    public static double Nosto(double saldo)
    {
        Console.WriteLine("Kuinka paljon haluat nostaa: ");
        double nosto = Convert.ToDouble(Console.ReadLine());
        
        if (saldo > 0.00 && nosto < saldo)
        {
            saldo = saldo - nosto;
            tiliTapahtumat(nosto);
        }
        else
        {
            Console.WriteLine("Tilillä ei ole katetta");
        }

        return saldo;
    }
    /// <summary>
    /// Aliohjelma joka lisaa tilille asiakkaan lisaaman summan
    /// </summary>
    /// <param name="saldo">parametrina viedaan alkuperäinen saldo</param>
    /// <returns>palauttaa lisatyn saldon</returns>
    public static double Talletus(double saldo)
    {
        Console.Write("Kuinka paljon haluat tallettaa tilille: ");
        double talletus = Convert.ToDouble(Console.ReadLine());

        saldo = saldo - talletus;
        tiliTapahtumat(talletus);
        return talletus;
    }
    /// <summary>
    /// Aliohjelma joka tuo asiakkaan tilin alkusaldon pin-koodin ollessa oikein
    /// </summary>
    /// <param name="luku">parametrina tuotu luku</param>
    /// <returns>palauttaa saldon</returns>
    public static double alkuSaldo(double luku)
    {
        double[] saldo = new double[1];
        return saldo[0] = luku;
        
    }
    /// <summary>
    /// Aliohjelma joka tulostaa tlin saldon
    /// </summary>
    /// <param name="saldo">parametrina viety tilin saldo</param>
    public static void tulostaSaldo(double saldo)
    {
        //double[] saldo = Saldo();
        Console.WriteLine("Tililla on rahaa " + "+ " + saldo + " euroa");
        Console.WriteLine("Paavalikkoon paase painamalla enter");
        string syote = Console.ReadLine();
    }
    /// <summary>
    /// Funktio joka palauttaa tilitapahtuminen taulukon
    /// </summary>
    /// <param name="maara">Parametrina annettu talletus tai nosto</param>
    /// <returns>Palauattaa merkkijonotaulukon tilitapahtumista</returns>
    public static string[] tiliTapahtumat(double maara)
    {
        string [] taulu = new string[30];
        string lisays = maara.ToString();
        taulu.Append(lisays);
        return taulu;
    }
    /// <summary>
    /// Aliohjelma joka tulostaa tilitapahtumat
    /// </summary>
    public static void tulostaTilitapahtumat()
    {
        double luku= 0;
        string[] taulu = tiliTapahtumat(luku);
        int viimeinen = taulu.Length - 1;
        string temp;
        for (int i = 0,j = viimeinen; i < j; i++,j--)
        {
            temp = taulu[i];
            taulu[i] = taulu[j];
            taulu[j] = temp;
        }

        for (int i = 0; i < taulu.Length; i++)
        {
            Console.WriteLine(taulu[i] + " euroa");
        }
        Console.WriteLine("alkuvalikkoon paaset painamalla enter");
        string merkki = Console.ReadLine();
    }
    /// <summary>
    /// Aliohjelma joka tulostaa naytolle ohjelmastapoistuttaessa
    /// </summary>
    public static void Lopetus()
    {
        Console.WriteLine("Kiitos kaynnista");
        Console.WriteLine("Tervetuloa uudelleen");
    }
}